Whamcloud - gitweb
LU-2391 build: separate lustre-osd-[ldiskfs,zfs] RPMs
[fs/lustre-release.git] / lustre.spec.in
index 44f085f..6a8ec1b 100644 (file)
@@ -20,6 +20,9 @@
 %{!?lustre_name: %global lustre_name lustre}
 %{!?build_lustre_tests: %global build_lustre_tests 1}
 
+%{!?build_lustre_osd_ldiskfs: %global build_lustre_osd_ldiskfs 1}
+%{!?build_lustre_osd_zfs: %global build_lustre_osd_zfs 1}
+
 # in order to get kernel symset and/or kernel module dependencies into
 # the RPM, in order to support weak-modules, the internal dependency gen-
 # erator needs to be disabled
 %define flavor %(bash -c "echo %{kversion} | sed -e 's/^.*-//'")
 %endif
 
+%if %is_client
+%define build_lustre_osd_ldiskfs 0
+%define build_lustre_osd_zfs 0
+%endif
+
 Summary: Lustre File System
 Name: %{lustre_name}
 Version: %{version}
@@ -82,13 +90,43 @@ Requires: kernel = %{krequires}
 %endif
 %endif
 %if ! %{is_client}
-Requires: lustre-backend-fs
+Requires: lustre-osd
 %endif
 Group: Development/Kernel
 
 %description modules
 Lustre file system, server and network drivers for Linux %{kversion}.
 
+%if %{build_lustre_osd_ldiskfs}
+%package osd-ldiskfs
+Summary: osd-ldiskfs is the mandatory glue for LDISKFS support in Lustre.
+Requires: lustre-modules = %{version}, lustre-ldiskfs
+Provides: lustre-osd
+Group: Development/Kernel
+
+%description osd-ldiskfs
+The Lustre Object Storage Device (OSD) API is the interface to access and
+modify data that is supposed to be stored persistently. This API is the interface
+to code that bridges individual file systems. This specific package provides an
+implementation of the OSD API for using the Ldiskfs filesystem as the underlying
+backing store of a Lustre server.
+%endif
+
+%if %{build_lustre_osd_zfs}
+%package osd-zfs
+Summary: osd-zfs is the mandatory glue for ZFS support in Lustre.
+Requires: lustre-modules = %{version}, zfs-modules
+Provides: lustre-osd
+Group: Development/Kernel
+
+%description osd-zfs
+The Lustre Object Storage Device (OSD) API is the interface to access and
+modify data that is supposed to be stored persistently. This API is the interface
+to code that bridges individual file systems. This specific package provides an
+implementation of the OSD API for using the ZFS filesystem as the underlying
+backing store of a Lustre server.
+%endif
+
 %package source
 Summary: Object-Based Disk storage driver source
 Group: Development/Kernel
@@ -267,7 +305,7 @@ if [ -d $RPM_BUILD_ROOT%{_libdir}/lustre/snmp ] ; then
   echo '%attr(-, root, root) %{_datadir}/lustre/snmp/mibs' >>lustre.files
 fi
 
-# Have universal lustre headers 
+# Have universal lustre headers
 if [ -f $RPM_BUILD_DIR/lustre-%{version}/lustre/include/lustre/lustre_idl.h ] ; then
   echo '%attr(-, root, root) /usr/include/linux/lustre_user.h' >>lustre.files
 else
@@ -281,28 +319,42 @@ fi
 %if %{build_lustre_tests}
 echo '%attr(-, root, root) %{_libdir}/lustre/tests/*' >lustre-tests.files
 echo '%attr(-, root, root) /lib/modules/%{kversion}/updates/kernel/fs/lustre/llog_test.*' >>lustre-tests.files
-modules_excludes="|llog_test"
 if [ -d $RPM_BUILD_ROOT%{_libdir}/lustre/liblustre/tests ] ; then
   echo '%attr(-, root, root) %{_libdir}/lustre/liblustre/tests/*' >>lustre-tests.files
 fi
 %endif
 
-pushd $RPM_BUILD_ROOT >/dev/null
-> $RPM_BUILD_DIR/lustre-%{version}/lustre-modules.files
-find lib/modules/%{kversion}/updates -type f | awk "!/(ZZZZZZZZZZ$modules_excludes)/ {print \"%attr(-, root, root) /\"\$0}" >>$RPM_BUILD_DIR/lustre-%{version}/lustre-modules.files
-popd >/dev/null
-
 # mark modules executable for find-debuginfo.sh
 find $RPM_BUILD_ROOT/lib/modules/%{kversion}/updates -name "*.ko" -type f | \
        xargs --no-run-if-empty chmod u+x
 
 %files -f lustre.files
 
-%files modules -f lustre-modules.files
+%files modules
+%attr(-, root, root) /lib/modules/%{kversion}/updates/*
+%if %{build_lustre_tests}
+%exclude /lib/modules/%{kversion}/updates/kernel/fs/lustre/llog_test.ko
+%endif
+%if %{build_lustre_osd_ldiskfs}
+%exclude /lib/modules/%{kversion}/updates/kernel/fs/lustre/osd_ldiskfs.ko
+%endif
+%if %{build_lustre_osd_zfs}
+%exclude /lib/modules/%{kversion}/updates/kernel/fs/lustre/osd_zfs.ko
+%endif
 %attr(-, root, root) %doc COPYING
 %attr(-, root, root) %doc ChangeLog-lustre
 %attr(-, root, root) %doc ChangeLog-lnet
 
+%if %{build_lustre_osd_ldiskfs}
+%files osd-ldiskfs
+%attr(-, root, root) /lib/modules/%{kversion}/updates/kernel/fs/lustre/osd_ldiskfs.ko
+%endif
+
+%if %{build_lustre_osd_zfs}
+%files osd-zfs
+%attr(-, root, root) /lib/modules/%{kversion}/updates/kernel/fs/lustre/osd_zfs.ko
+%endif
+
 %files source
 %attr(-, root, root) /usr/src/lustre-%{version}
 
@@ -349,10 +401,96 @@ if sysctl kernel.unsupported >/dev/null 2>&1 &&
      into /etc/modprobe.d/unsupported_modules"
 fi
 
+%if %{build_lustre_osd_ldiskfs}
+%post osd-ldiskfs
+if [ -f /boot/System.map-%{kversion} ]; then
+       depmod -ae -F /boot/System.map-%{kversion} %{kversion} || exit 0
+else
+       depmod -ae %{kversion} || exit 0
+fi
+
+OSD_LDISKFS_RPM_NAME=$(rpm -q %{name}-osd-ldiskfs | grep "%{version}-%{release}")
+# "weak modules" support
+# Suse
+if [ -x /usr/lib/module-init-tools/weak-modules ]; then
+    rpm -ql $OSD_LDISKFS_RPM_NAME | grep '\.ko$' |
+        /usr/lib/module-init-tools/weak-modules --add-modules
+fi
+# RedHat
+if [ -x /sbin/weak-modules ]; then
+    rpm -ql $OSD_LDISKFS_RPM_NAME | grep '\.ko$' |
+        /sbin/weak-modules --add-modules
+fi
+
+# If the kernel was built to reject unsupported modules (e.g. not a Lustre
+# kernel), and this hasn't been overridden in /etc/modprobe.d yet, then
+# print a warning so that users are aware of this issue.
+if sysctl kernel.unsupported >/dev/null 2>&1 &&
+   [ "$(sysctl -n kernel.unsupported 2>/dev/null)" = "0" ] &&
+    ! modprobe -c | grep -q "^allow_unsupported_modules[ \t]1" ; then
+     echo "
+     warning: the Lustre modules are not supported by Novell. To use Lustre
+              on this system, you should put
+
+     allow_unsupported_modules 1
+
+     into /etc/modprobe.d/unsupported_modules"
+fi
+%endif
+
+%if %{build_lustre_osd_zfs}
+%post osd-zfs
+if [ -f /boot/System.map-%{kversion} ]; then
+       depmod -ae -F /boot/System.map-%{kversion} %{kversion} || exit 0
+else
+       depmod -ae %{kversion} || exit 0
+fi
+
+OSD_ZFS_RPM_NAME=$(rpm -q %{name}-osd-zfs | grep "%{version}-%{release}")
+# "weak modules" support
+# Suse
+if [ -x /usr/lib/module-init-tools/weak-modules ]; then
+    rpm -ql $OSD_ZFS_RPM_NAME | grep '\.ko$' |
+        /usr/lib/module-init-tools/weak-modules --add-modules
+fi
+# RedHat
+if [ -x /sbin/weak-modules ]; then
+    rpm -ql $OSD_ZFS_RPM_NAME | grep '\.ko$' |
+        /sbin/weak-modules --add-modules
+fi
+
+# If the kernel was built to reject unsupported modules (e.g. not a Lustre
+# kernel), and this hasn't been overridden in /etc/modprobe.d yet, then
+# print a warning so that users are aware of this issue.
+if sysctl kernel.unsupported >/dev/null 2>&1 &&
+   [ "$(sysctl -n kernel.unsupported 2>/dev/null)" = "0" ] &&
+    ! modprobe -c | grep -q "^allow_unsupported_modules[ \t]1" ; then
+     echo "
+     warning: the Lustre modules are not supported by Novell. To use Lustre
+              on this system, you should put
+
+     allow_unsupported_modules 1
+
+     into /etc/modprobe.d/unsupported_modules"
+fi
+%endif
+
 %preun modules
 MODULES_RPM_NAME=$(rpm -q %{name}-modules | grep "%{version}-%{release}")
 rpm -ql $MODULES_RPM_NAME | grep '\.ko$' > /var/run/%{name}-modules || true
 
+%if %{build_lustre_osd_ldiskfs}
+%preun osd-ldiskfs
+OSD_LDISKFS_RPM_NAME=$(rpm -q %{name}-osd-ldiskfs | grep "%{version}-%{release}")
+rpm -ql $OSD_LDISKFS_RPM_NAME | grep '\.ko$' > /var/run/%{name}-osd-ldiskfs || true
+%endif
+
+%if %{build_lustre_osd_zfs}
+%preun osd-zfs
+OSD_ZFS_RPM_NAME=$(rpm -q %{name}-osd-zfs | grep "%{version}-%{release}")
+rpm -ql $OSD_ZFS_RPM_NAME | grep '\.ko$' > /var/run/%{name}-osd-zfs || true
+%endif
+
 %postun modules
 if [ -f /boot/System.map-%{kversion} ]; then
        depmod -ae -F /boot/System.map-%{kversion} %{kversion} || exit 0
@@ -373,6 +511,50 @@ if [ -x /sbin/weak-modules ]; then
 fi
 rm /var/run/%{name}-modules
 
+%if %{build_lustre_osd_ldiskfs}
+%postun osd-ldiskfs
+if [ -f /boot/System.map-%{kversion} ]; then
+       depmod -ae -F /boot/System.map-%{kversion} %{kversion} || exit 0
+else
+       depmod -ae %{kversion} || exit 0
+fi
+
+# "weak modules" support
+# Suse
+if [ -x /usr/lib/module-init-tools/weak-modules ]; then
+    cat /var/run/%{name}-osd-ldiskfs |
+        /usr/lib/module-init-tools/weak-modules --remove-modules
+fi
+# RedHat
+if [ -x /sbin/weak-modules ]; then
+    cat /var/run/%{name}-osd-ldiskfs |
+        /sbin/weak-modules --remove-modules
+fi
+rm /var/run/%{name}-osd-ldiskfs
+%endif
+
+%if %{build_lustre_osd_zfs}
+%postun osd-zfs
+if [ -f /boot/System.map-%{kversion} ]; then
+       depmod -ae -F /boot/System.map-%{kversion} %{kversion} || exit 0
+else
+       depmod -ae %{kversion} || exit 0
+fi
+
+# "weak modules" support
+# Suse
+if [ -x /usr/lib/module-init-tools/weak-modules ]; then
+    cat /var/run/%{name}-osd-zfs |
+        /usr/lib/module-init-tools/weak-modules --remove-modules
+fi
+# RedHat
+if [ -x /sbin/weak-modules ]; then
+    cat /var/run/%{name}-osd-zfs |
+        /sbin/weak-modules --remove-modules
+fi
+rm /var/run/%{name}-osd-zfs
+%endif
+
 %if %{build_lustre_tests}
 %post tests
 if [ -f /boot/System.map-%{kversion} ]; then